{$M 50000,0,32767}
{$O+}
(****************************************************************************
 ** UNIT: Setup3.Pas                                                       **
 ** PURPOSE: To provide the actual submenus in the setup program.          **
 ****************************************************************************)


unit Setup3;

interface

uses Setup2, Dos, Crt, common, TextJKL, TimeFunc;


(* Procedures *)

procedure Misc(var systemf: systemrec);
(* The Miscellaneous Setup Screen *)
procedure Paths(var systemf: systemrec);
(* The Paths Setup Screen *)
procedure Modem(var modemf: modemrec);
(* The Modem Setup Screen *)
procedure Conf(var systemf: systemrec);
(* The Conference Setup Screen *)


(* Functions *)

function Where(MenuT,Max,AddX,AddY:Byte;UseLetter:Boolean;I:byte): byte;
(* Main procedure to navigate menus *)

implementation

procedure Backslash(var t: string);
var x: byte;
begin
  x := ord(t[0]);
  if t[x] <> '\' then t := t + '\';
end;

procedure WriteStr(Ch: char; s:string);
begin
textattr := darkgray;
write(ch);
textattr := lightgray;
write(')');
textattr := darkgray;
writeln(' '+s);
end;

procedure Config_Screen;
const
  Config_WIDTH=80;
  Config_DEPTH=25;
  Config_LENGTH=687;
  Config : array [1..687] of Char = (
     #9,#17,'',' ',#14,'O','N','Y','X',' ','B','B','S',' ','C','o','n',
    'f','i','g','u','r','a','t','i','o','n',' ','v','.','6','9',' ', #0,
    '',' ','D','a','r','k','h','a','w','k',' ','&',' ','E','l','v','e',
    'n',' ','S','t','a','r',' ','',' ',#15,'[', #7,'E','S','C',#15,']',
    ' ','E','s','c','a','p','e','s',' ','P','r','o','g','r','a','m',' ',
    ' ', #9,'',#24,#24,#24,#24,#16,#25,'$', #7,'',#24,#25,'$','',#24,
    #25,'$','',#25, #2, #8,'','','','','','','',' ','','','',
    #25, #3,'','','','','','','',#25, #2,'','',' ','','','',
    #25, #2,'','','',#24,#25,'#', #7,'',#15,#23,'',#16,'',' ', #8,
    #26, #4,'','','','',' ',#26, #3,'','',' ',' ','','','',' ',
    '','','','','',' ','','',' ','','','','',' ','','','',
    '',#24,'[',' ', #7,'M','i','s','c','e','l','l','a','n','e','o','u',
    's',#25, #6, #8,']',#25,#11, #7,'',#15,#23,'',#16,'','','', #8,
    '','','',#25, #2,'','',' ',#26, #5,'','','','','',#25, #2,
    '',#26, #5,'',' ','',#26, #4,'','',#24,'[',' ', #7,'P','a','t',
    'h','s',' ','a','n','d',' ','F','i','l','e','n','a','m','e','s',' ',
     #8,']',#25, #5, #7,'',' ',' ',#15,'', #7,'',#15,#23,'','',#16,
    #26, #4,'','','', #7,'',#15,'',' ', #8,'','',' ','','','',
    ' ','',#26, #4,'',#25, #4,'',#26, #3,'',' ','',#26, #4,'','',
    #24,'[',' ', #7,'M','o','d','e','m',' ','S','e','t','u','p',#25, #8,
     #8,']',#25,#10, #7,'',#15,#23,'',#16,#26, #3,'','', #8,'','',
    '',' ','','','',' ','','','',#25, #2,'','','','',#25, #5,
    '','','',' ','','','','',' ','','','','',#24,'[',' ', #7,
    'C','o','n','f','e','r','e','n','c','e','s',#25, #8, #8,']',#25,#11,
     #7,'',#15,#23,'',#16,'','','', #8,'',#26, #6,'',' ','','',
    '',#25, #3,'',' ',#26, #9,'',' ','','','',#25, #2,'','','',
    #24,'[',' ', #7,'I','n','f','o','f','o','r','m','s',#25,#10, #8,']',
    #25,#12, #7,'',#15,'','',#25, #3, #8,'','','',#25, #2,'','',
    '',#25, #3,'',' ',#26, #8,'',' ',' ','','','',#25, #2,'','',
    '',#24,'[',' ', #7,'C','h','a','t',' ','M','o','d','e','s',#25, #9,
     #8,']',#25,#12, #7,'',#15,#23,'',#16,'',#25, #6, #8,'W','r','i',
    't','t','e','n',' ','b','y',' ',':',' ','D','a','r','k','h','a','w',
    'k',#24,'[',' ', #7,'Q','u','i','t',#25,#15, #8,']',#25,#13, #7,'',
    #25, #5, #8,'A','n','s','i',' ','S','u','p','p','o','r','t',' ',':',
    ' ','T','h','e',' ','E','l','v','e','n',' ','S','t','a','r',#24,#25,
    '$', #7,'',#24,#25,'$','',#24,#24,#25,'$','',#24,#24,#24,#24,#24,
    #24, #9,#17,'',#25, #9, #0,'',#25, #2,#15,'[', #7,'E','N','T','E',
    'R',#15,']',' ','S','e','l','e','c','t','s',' ','A','n','o','t','h',
    'e','r',' ','M','e','n','u',#25, #2, #0,'',#25, #4,#15,'A','r','r',
    'o','w',' ','K','e','y','s',' ','M','o','v','e',' ','C','u','r','s',
    'o','r',#25, #4, #9,'',#24);

begin
  uncrunch(config,screenadr,Config_Length);
end;



function Where(MenuT,Max,AddX,AddY:Byte;UseLetter:Boolean;I:byte): byte;
 var
  Hi,Lo:byte;
  c: char;
  menu:menubar;
  f: file of systemrec;
  m: file of modemrec;
  h: file of historyrec;

 Procedure Main;
  Begin
   with menu do
    begin
     Lo := 7;
     Hi := 15;
     textbackground(black);
     clrscr;
     Config_Screen;
     addselection('Miscellaneous',1,AddX,AddY,Lo);
     addselection('Paths and Filenames',2,AddX,AddY,Lo);
     addselection('Modem Setup',3,AddX,AddY,Lo);
     addselection('Conferences',4,AddX,AddY,Lo);
     addselection('Infoforms',5,AddX,AddY,Lo);
     addselection('Chat Modes',6,AddX,AddY,Lo);
     AddSelection('Quit',7,AddX,AddY,Lo);
     highlight(i,AddX,AddY,Hi);
    end;
  End;

 Procedure Miscellaneous;
  Begin
   With Menu do
    Begin
     Lo := 8;
     Hi := 15;
     addselection('A',01,AddX,AddY,Lo);
     addselection('B',02,AddX,AddY,Lo);
     addselection('C',03,AddX,AddY,Lo);
     addselection('D',04,AddX,AddY,Lo);
     addselection('E',05,AddX,AddY,Lo);
     addselection('F',06,AddX,AddY,Lo);
     AddSelection('G',07,AddX,AddY,Lo);
     addselection('H',08,AddX,AddY,Lo);
     addselection('I',09,AddX,AddY,Lo);
     addselection('J',10,AddX,AddY,Lo);
     Highlight(i,AddX,AddY,Hi);
    End;
  End;

 Procedure PathC;
  Begin
   With Menu do
    Begin
     Lo := 8;
     Hi := 15;
     addselection('A',01,AddX,AddY,Lo);
     addselection('B',02,AddX,AddY,Lo);
     addselection('C',03,AddX,AddY,Lo);
     addselection('D',04,AddX,AddY,Lo);
     addselection('E',05,AddX,AddY,Lo);
     addselection('F',06,AddX,AddY,Lo);
     AddSelection('G',07,AddX,AddY,Lo);
     addselection('H',08,AddX,AddY,Lo);
     addselection('I',09,AddX,AddY,Lo);
     addselection('J',10,AddX,AddY,Lo);
     Highlight(i,AddX,AddY,Hi);
    End;
  End;

 Procedure ModemC;
  Begin
   With Menu do
    Begin
     Lo := 8;
     Hi := 15;
     addselection('A',01,AddX,AddY,Lo);
     addselection('B',02,AddX,AddY,Lo);
     addselection('C',03,AddX,AddY,Lo);
     addselection('D',04,AddX,AddY,Lo);
     addselection('E',05,AddX,AddY,Lo);
     addselection('F',06,AddX,AddY,Lo);
     AddSelection('G',07,AddX,AddY,Lo);
     addselection('H',08,AddX,AddY,Lo);
     Highlight(i,AddX,AddY,Hi);
    End;
  End;

 Procedure ConfC;
  Begin
   With Menu do
    Begin
     Lo := 8;
     Hi := 15;
     addselection('A',01,AddX,AddY,Lo);
     addselection('B',02,AddX,AddY,Lo);
     addselection('C',03,AddX,AddY,Lo);
     addselection('D',04,AddX,AddY,Lo);
     addselection('E',05,AddX,AddY,Lo);
     addselection('F',06,AddX,AddY,Lo);
     AddSelection('G',07,AddX,AddY,Lo);
     addselection('H',08,AddX,AddY,Lo);
     addselection('I',09,AddX,AddY,Lo);
     addselection('J',10,AddX,AddY,Lo);
     addselection('K',11,AddX,AddY,Lo);
     addselection('L',12,AddX,AddY,Lo);
     addselection('M',13,AddX,AddY,Lo);
     addselection('N',14,AddX,AddY,Lo);
     addselection('O',15,AddX,AddY,Lo);
     addselection('P',16,AddX,AddY,Lo);
     Highlight(i,AddX,AddY,Hi);
    End;
  End;

begin
  Case Menut of
   1:Main;
   2:Miscellaneous;
   3:PathC;
   4:ModemC;
   5:ConfC;
  End;
  repeat
    repeat
      textcolor(yellow);
      textbackground(blue);
      writeat(4,25,time);
      textcolor(white);
      textbackground(black);
    until keypressed;
    C := readkey;
    case c of
      #27,'Q','q': begin
                     assign(f, 'setup.dat');
                     Rewrite(F);
                     Write(F,SystemF);
                     Close(F);
                     assign(m, systemf.datapath+'modem.dat');
                     Rewrite(M);
                     Write(M,ModemF);
                     Close(M);
                     assign(h, systemf.datapath+'history.dat');
                     Rewrite(H);
                     Write(H,HistoryF);
                     Close(H);
                     I := Max+1;
                     C := #13;
                   end;
       #72: begin
              dec(i);
              if i < 1 then
              begin
                i := Max;
                menu.unhighlight(1,AddX,AddY,Lo);
                menu.highlight(i,AddX,AddY,Hi);
              end
              else
              begin
                menu.UnHighLight(i+1,AddX,AddY,Lo);
                menu.HighLight(i,AddX,AddY,Hi);
              end;
            end;
      #80: begin
             inc(i);
             if i > Max then
             begin
               i := 1;
               menu.unhighlight(Max,AddX,AddY,Lo);
               menu.highlight(i,AddX,AddY,Hi);
             end
             else
             begin
               menu.UnHighLight(i-1,AddX,AddY,Lo);
               menu.HighLight(i,AddX,AddY,Hi);
             end;
           end;
     else
      if UseLetter then
        if (C > #64) and (C < chr(Max+65)) then
        begin
          menu.unhighlight(i,AddX,AddY,Lo);
          i := ord(ord(C)-64);
          C := #13;
          menu.highlight(i,AddX,AddY,Hi);
        end
        else
          if (C > #96) and (C < chr(Max+97)) then
          begin
           menu.unhighlight(i,AddX,AddY,Lo);
           i := ord(ord(C)-96);
           C := #13;
           menu.highlight(i,AddX,AddY,Hi);
          end;
    end;
  until c = #13;
  where := i;
end;

procedure Misc(var systemf: systemrec);

var
  c: char;
  t: string;
  i: Byte;
begin
  textbackground(black);
  clrscr;
  textbackground(blue);
  textcolor(lightblue);
  gotoxy(1,1);
  write(' '); textcolor(yellow);
  write('ONYX BBS Configuration v.69 '); textcolor(black);
  write(' Darkhawk & Elven Star  '); textcolor(white);
  write('['); textcolor(lightgray); write('ESC'); textcolor(white);
  write('] Escapes Menu     '); textcolor(lightblue); write('');
  gotoxy(1,25); textcolor(lightblue); write('   '); textcolor(yellow);
  write('       '); textcolor(black); write(' Miscellaneous Setup  ');
  textcolor(white); write('Press Letter To Change Current Setup       ');
  textcolor(lightblue); write('');
  textbackground(black);
  gotoxy(1,5);
  writestr('A','Long BBS Name    : ');
  writestr('B','Short BBS Name   : ');
  writestr('C','BBS Phone #      : ');
  writestr('D','SysOp Handle     : ');
  writestr('E','New User Password: ');
  writestr('F','Lockout Baud Rate: ');
  writestr('G','Lockout Password : ');
  writestr('H','System1 Password : ');
  writestr('I','System2 Password : ');
  writestr('J','System3 Password : ');
  I:=1;
  repeat
    textcolor(yellow);
    textbackground(blue);
    writeat(4,25,time);
    textcolor(white);
    textbackground(black);
    writeat(23,5,systemf.bbsnamelng);
    writeat(23,6,systemf.bbsnamesht);
    writeat(23,7,systemf.bbsphone);
    writeat(23,8,systemf.sysop);
    writeat(23,9,systemf.nup);
    writeat(23,10,systemf.lockoutbaud);
    writeat(23,11,systemf.lockoutpw);
    writeat(23,12,systemf.system);
    I := Where(2,10,1,4,True,i);
    case i of
      1      : begin
                 t:=systemf.bbsnamelng;
                 InputS(23,5,1,t,50);
                 systemf.bbsnamelng:=t;
               end;
      2      : begin
                 t:=systemf.bbsnamesht;
                 InputS(23,6,1,t,30);
                 systemf.bbsnamesht:=t;
               end;
      3      : begin
                 t:=systemf.bbsphone;
                 InputS(23,7,1,t,12);
                 systemf.bbsphone:=t;
               end;
      4      : begin
                 t:=systemf.sysop;
                 InputS(23,8,1,t,30);
                 systemf.sysop:=t;
               end;
      5      : begin
                 t:=systemf.nup;
                 InputS(23,9,1,t,50);
                 systemf.nup:=t;
               end;
      6      : begin
                 t:=systemf.lockoutbaud;
                 InputS(23,10,1,t,6);
                 systemf.lockoutbaud:=t;
               end;
      7      : begin
                 t:=systemf.lockoutpw;
                 InputS(23,11,1,t,50);
                 systemf.lockoutpw:=t;
               end;
      8      : begin
                 t:=systemf.system;
                 InputS(23,12,1,t,50);
                 systemf.system:=t;
               end;
    end;
  until i=11;
end;

procedure Paths(var systemf: systemrec);

var
  i:Byte;
  t: string;
begin
  textbackground(black);
  clrscr;
  textbackground(blue);
  textcolor(lightblue);
  gotoxy(1,1);
  write(' '); textcolor(yellow);
  write('ONYX BBS Configuration v.69 '); textcolor(black);
  write(' Darkhawk & Elven Star  '); textcolor(white);
  write('['); textcolor(lightgray); write('ESC'); textcolor(white);
  write('] Escapes Menu     '); textcolor(lightblue); write('');
  gotoxy(1,25); textcolor(lightblue); write('   '); textcolor(yellow);
  write('       '); textcolor(black); write(' Paths Configuration  ');
  textcolor(white); write('Press Letter To Change Current Setup       ');
  textcolor(lightblue); write('');
  textbackground(black);
  gotoxy(1,5);
  writestr('A','Main BBS Path   : ');
  writestr('B','Data Path       : ');
  writestr('C','Message Path    : ');
  writestr('D','Textfile Path   : ');
  writestr('E','Menu Path       : ');
  writestr('F','Transfer Path   : ');
  writestr('G','Temporary Path  : ');
  writestr('H','DSZ Filename    : ');
  writestr('I','PKZIP Filename  : ');
  writestr('J','PKUNZIP Filename: ');
  I:=1;
  repeat
    textcolor(white);
    textbackground(black);
    writeat(22,5,systemf.mainpath);
    writeat(22,6,systemf.datapath);
    writeat(22,7,systemf.messagepath);
    writeat(22,8,systemf.textfilepath);
    writeat(22,9,systemf.menupath);
    writeat(22,10,systemf.xferpath);
    writeat(22,11,systemf.temppath);
    writeat(22,12,systemf.zmodem);
    writeat(22,13,systemf.zip);
    writeat(22,14,systemf.unzip);
    I := Where(3,10,1,4,True,i);
    case i of
        1    : begin
                 t:=systemf.mainpath;
                 InputS(22,5,1,t,50);
                 Backslash(t);
                 systemf.mainpath:=t;
               end;
        2    : begin
                 t:=systemf.datapath;
                 InputS(22,6,1,t,50);
                 Backslash(t);
                 systemf.datapath:=t;
               end;
        3    : begin
                 t:=systemf.messagepath;
                 InputS(22,7,1,t,50);
                 Backslash(t);
                 systemf.messagepath:=t;
               end;
        4    : begin
                 t:=systemf.textfilepath;
                 InputS(22,8,1,t,50);
                 Backslash(t);
                 systemf.textfilepath:=t;
               end;
        5    : begin
                 t:=systemf.menupath;
                 InputS(22,9,1,t,50);
                 Backslash(t);
                 systemf.menupath:=t;
               end;
        6    : begin
                 t:=systemf.xferpath;
                 InputS(22,10,1,t,50);
                 Backslash(t);
                 systemf.xferpath:=t;
               end;
        7    : begin
                 t:=systemf.temppath;
                 InputS(22,11,1,t,50);
                 Backslash(t);
                 systemf.temppath:=t;
               end;
        8    : begin
                 t:=systemf.zmodem;
                 InputS(22,12,1,t,50);
                 systemf.zmodem:=t;
               end;
        9    : begin
                 t:=systemf.zip;
                 InputS(22,13,1,t,50);
                 systemf.zip:=t;
               end;
        10   : begin
                 t:=systemf.unzip;
                 InputS(22,14,1,t,50);
                 systemf.unzip:=t;
               end;
    end;
  until i=11;
end;

procedure Modem(var modemf: modemrec);

var
  t: string;
  i:Byte;
begin
  textbackground(black);
  clrscr;
  textbackground(blue);
  textcolor(lightblue);
  gotoxy(1,1);
  write(' '); textcolor(yellow);
  write('ONYX BBS Configuration v.69 '); textcolor(black);
  write(' Darkhawk & Elven Star  '); textcolor(white);
  write('['); textcolor(lightgray); write('ESC'); textcolor(white);
  write('] Escapes Menu     '); textcolor(lightblue); write('');
  gotoxy(1,25); textcolor(lightblue); write('   '); textcolor(yellow);
  write('       '); textcolor(black); write(' Modem Configuration  ');
  textcolor(white); write('Press Letter To Change Current Setup       ');
  textcolor(lightblue); write('');
  textbackground(black);
  gotoxy(1,5);
  writestr('A','Modem Speed     : ');
  writestr('B','Com Port #      : ');
  writestr('C','Init String     : ');
  writestr('D','Hangup String   : ');
  writestr('E','Answer String   : ');
  writestr('F','Off-Hook String : ');
  writestr('G','Sound On String : ');
  writestr('H','Sound Off String: ');
  I:=1;
  repeat
    textcolor(white);
    textbackground(black);
    writeat(22,5,v2str(modemf.speed));
    writeat(22,6,v2str(modemf.comport));
    writeat(22,7,modemf.initstr);
    writeat(22,8,modemf.hangupstr);
    writeat(22,9,modemf.answerstr);
    writeat(22,10,modemf.offhookstr);
    writeat(22,11,modemf.soundonstr);
    writeat(22,12,modemf.soundoffstr);
    I := Where(4,8,1,4,True,i);
    case i of
    1        : begin
                 t:=v2str(modemf.speed);
                 InputS(22,5,1,t,6);
                 modemf.speed:=str2v(t);
               end;
     2       : begin
                 t:=v2str(modemf.comport);
                 InputS(22,6,1,t,1);
                 modemf.comport:=str2v(t);
               end;
      3      : begin
                 t:=modemf.initstr;
                 InputS(22,7,1,t,50);
                 modemf.initstr:=t;
               end;
       4     : begin
                 t:=modemf.hangupstr;
                 InputS(22,8,1,t,50);
                 modemf.hangupstr:=t;
               end;
        5    : begin
                 t:=modemf.answerstr;
                 InputS(22,9,1,t,50);
                 modemf.answerstr:=t;
               end;
         6   : begin
                 t:=modemf.offhookstr;
                 InputS(22,10,1,t,50);
                 modemf.offhookstr:=t;
               end;
          7  : begin
                 t:=modemf.soundonstr;
                 InputS(22,11,1,t,50);
                 modemf.soundonstr:=t;
               end;
           8 : begin
                 t:=modemf.soundoffstr;
                 InputS(22,12,1,t,50);
                 modemf.soundoffstr:=t;
               end;
    end;
  until i=9;
end;

procedure Conf(var systemf: systemrec);

var
  t: string;
  i: Byte;
begin
  textbackground(black);
  clrscr;
  textbackground(blue);
  textcolor(lightblue);
  gotoxy(1,1);
  write(' '); textcolor(yellow);
  write('ONYX BBS Configuration v.69 '); textcolor(black);
  write(' Darkhawk & Elven Star  '); textcolor(white);
  write('['); textcolor(lightgray); write('ESC'); textcolor(white);
  write('] Escapes Menu     '); textcolor(lightblue); write('');
  gotoxy(1,25); textcolor(lightblue); write('   '); textcolor(yellow);
  write('       '); textcolor(black); write('  Conferences Setup   ');
  textcolor(white); write('Press Letter To Change Current Setup       ');
  textcolor(lightblue); write('');
  textbackground(black);
  gotoxy(1,5);
  writestr('A','Use Conferences  : ');
  writestr('B','Use Conference #1: ');
  writestr('C','Message Base Name: ');
  writestr('D','File Base Name   : ');
  writestr('E','Use Conferenct #2: ');
  writestr('F','Message Base Name: ');
  writestr('G','File Base Name   : ');
  writestr('H','Use Conference #3: ');
  writestr('I','Message Base Name: ');
  writestr('J','File Base Name   : ');
  writestr('K','Use Conference #4: ');
  writestr('L','Message Base Name: ');
  writestr('M','File Base Name   : ');
  writestr('N','Use Conference #5: ');
  writestr('O','Message Base Name: ');
  writestr('P','File Base Name   : ');
  I:=1;
  repeat
    textcolor(white);
    textbackground(black);
    writeat(23,5,b2str(systemf.useconfs));
    writeat(23,6,b2str(systemf.useconf[1]));
    writeat(23,7,systemf.confa[1]);
    writeat(23,8,systemf.confb[1]);
    writeat(23,9,b2str(systemf.useconf[2]));
    writeat(23,10,systemf.confa[2]);
    writeat(23,11,systemf.confb[2]);
    writeat(23,12,b2str(systemf.useconf[3]));
    writeat(23,13,systemf.confa[3]);
    writeat(23,14,systemf.confb[3]);
    writeat(23,15,b2str(systemf.useconf[4]));
    writeat(23,16,systemf.confa[4]);
    writeat(23,17,systemf.confb[4]);
    writeat(23,18,b2str(systemf.useconf[5]));
    writeat(23,19,systemf.confa[5]);
    writeat(23,20,systemf.confb[5]);

    I := Where(5,16,1,4,True,i);
    case i of
      1      : begin
                 toggle(systemf.useconfs);
               end;
      2      : begin
                 toggle(systemf.useconf[1]);
               end;
      3      : begin
                 t:=systemf.confa[1];
                 InputS(23,7,1,t,50);
                 systemf.confa[1]:=t;
               end;
      4     : begin
                 t:=systemf.confb[1];
                 InputS(23,8,1,t,50);
                 systemf.confb[1]:=t;
               end;
      5      : begin
                 toggle(systemf.useconf[2]);
               end;
      6      : begin
                 t:=systemf.confa[2];
                 InputS(23,10,1,t,50);
                 systemf.confa[2]:=t;
               end;
      7      : begin
                 t:=systemf.confb[2];
                 InputS(23,11,1,t,50);
                 systemf.confb[2]:=t;
               end;
      8      : begin
                 toggle(systemf.useconf[3]);
               end;
      9      : begin
                 t:=systemf.confa[3];
                 InputS(23,13,1,t,50);
                 systemf.confa[3]:=t;
               end;
      10     : begin
                 t:=systemf.confb[3];
                 InputS(23,14,1,t,50);
                 systemf.confb[3]:=t;
               end;
      11     : begin
                 toggle(systemf.useconf[4]);
               end;
      12     : begin
                 t:=systemf.confa[4];
                 InputS(23,16,1,t,50);
                 systemf.confa[4]:=t;
               end;
      13     : begin
                 t:=systemf.confb[4];
                 InputS(23,17,1,t,50);
                 systemf.confb[4]:=t;
               end;
      14     : begin
                 toggle(systemf.useconf[5]);
               end;
      15     : begin
                 t:=systemf.confa[5];
                 InputS(23,19,1,t,50);
                 systemf.confa[5]:=t;
               end;
      16     : begin
                 t:=systemf.confb[5];
                 InputS(23,20,1,t,50);
                 systemf.confb[5]:=t;
               end;
    end;
  until i=17;
end;

end.
